Unit ama1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ama1e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var D :Extended; var E :Extended;
                var HM :Extended; var P :Integer);

implementation

procedure ama1e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var D :Extended; var E :Extended;
                var HM :Extended; var P :Integer);
var
I,J,L :Integer;
Z :Real;
S,V,G,T :Extended;
const
WM3 :Extended = 2.0e-292;
WMM :Extended = 2.0e0;
label
_1,_2,_3,_4,_5,_6;
begin
{      WMM= SQRT(SYS053*SYS055) }
{      WM3= SYS055/SYS051 }
P := 0;
S := Abs(B[1]);
for J:=2 to N do
 begin
_1:
  S := EMax1(S,Abs(B[J-1]));
 end;
if ( S <= WMM ) 
 then goto _2;
P := 1;
HM := WMM/S;
_2:
B[0] := 0.e0;
Z := Abs(B[N-1]);
E := A[N-1]+S;
D := A[N-1]-S;
L := N-1;
for I:=1 to L do
 begin
  J := N-I;
  T := S;
  S := Abs(B[J-1]);
  V := A[J-1];
  G := T+S;
  E := EMax1(E,V+G);
_3:
  D := EMin1(D,V-G);
 end;
if ( P = 1 ) 
 then goto _4;
G := EMax1(Abs(E),Abs(D));
if ( G >= WM3 ) 
 then goto _6;
if ( G = 0.e0 ) 
 then goto _6;
HM := WM3/G;
P := 1;
_4:
for I:=1 to N do
 begin
  A[I-1] := A[I-1]*HM;
_5:
  B[I-1] := B[I-1]*HM;
 end;
E := E*HM;
D := D*HM;
_6:
end;

end.
